#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define __EXC_INTERNAL
#include <exc.h>

#if defined(__DJGPP__)
#error DEMO_2 not for djgpp
#endif

volatile unsigned int maxI = 1000000;

void LoopProc (char *p)
{
  int i;
  for (i = 0; i < maxI; i++)
      *p = 0;
}

void Exc_13_Continue (void)
{
 /* continue at instruction after *p=0 in above for-loop.
  * Generate ASM/LST output to make sure correct offset is used
  */
  context.EIP += 3;
}

char * Delta_ms (clock_t dt)
{
  static char buf[10];
  double delta = 1000.0 * (double) dt / (double)CLOCKS_PER_SEC;
  sprintf (buf, "%6.1f", delta);
  return (buf);
}   

int main (int argc, char **argv)
{
  clock_t start, dt1, dt2;
  char    dummy;

  InstallExcHandler (NO_EXC_HOOK);
  excHookMain = Exc_13_Continue;
  clock();

  if (argc == 2 && atoi(argv[1]) > 0)
     maxI = atoi (argv[1]);

  printf ("Timing %u exception 13.. ", maxI);
  fflush (stdout);
  start = clock();
  LoopProc ((char*)-1);     /* causes exception 13 */
  dt1 = clock() - start;
  printf ("%s mS\n", Delta_ms(dt1));

  printf ("Timing %u empty loops... ", maxI);
  fflush (stdout);
  start = clock();
  LoopProc (&dummy);        /* point to safe location */
  dt2   = clock() - start;
  printf ("%s mS\n", Delta_ms(dt2));

  printf ("Exception overhead........... %s S\n", Delta_ms(1000*(dt1-dt2)/maxI));
  printf ("Exceptions per second........ %6u\n", CLOCKS_PER_SEC*maxI/dt1);
  return (0);
}

