#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <float.h>
#include <conio.h>
#include <exc.h>

#ifdef __FLAT__
#define SIGALRM 14
#endif
                
void SigHandler (int sig);  /* signal handler cannot be at offset 0 */

int main (int argc, char **argv)
{
  double x = 0.0;
  double y;

  if (argc < 2)
  {
    printf ("Usage: %s [1 | 2 | 3]\n" \
            "\t 1 - test SIGINT\n"    \
            "\t 2 - test SIGFPE\n"    \
            "\t 3 - test SIGALRM\n"   \
            "\t 4 - test SIGSEGV\n",argv[0]);
    return (0);
  }

  switch (argv[1][0])
  {
    case '1': _signal (SIGINT, SigHandler);  /* test SIGINT */
              while (1)
              {
                if (kbhit())
                   printf ("getch() = %02X\n", getch());
              }
              break;

    case '2': _control87 (0,MCW_EM); /* enable exceptions */
              _signal (SIGFPE, SigHandler);
              y = 1.0/x;             /* cause SIGFPE              */
              x = y*2.0;             /* needed cause' y is unused */
              break;

    case '3': _alarm (10);
              _signal (SIGALRM,SigHandler);  /* test SIGALRM */
              _signal (SIGINT, SigHandler);  /* test SIGINT also */
              _pause();
              break;

    case '4': _signal (SIGSEGV,SigHandler);  /* test SIGSEGV */
              *((char*)-1) = 0;
              break;
  }

  puts ("Continuing after SIG !!??");
  return (0);
}

void SigHandler (int sig)
{
  switch (sig)
  {
    case SIGINT:  puts ("SIGINT caught");
                  break;
    case SIGFPE:  puts ("SIGFPE caught");
                  break;
    case SIGSEGV: puts ("SIGSEGV caught");
                  break;
    case SIGALRM: puts ("SIGALRM caught");
                  break;
  }
  _raise (SIGABRT); /* do normal exception exit (reg-dump, dis-asm) */
  exit (0);
}

