/*
 *  A simple demo program to test exception handling
 *  and disassembly of C++ sources
 */

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

#define __EXC_INTERNAL
#include <exc.h>

/*
 *  Class definition
 */
class CExcHandler
{
  int type;
public:
  CExcHandler (int);
  ~CExcHandler ();
  void crash ();
};

/*
 *  Class implementation
 */
CExcHandler::CExcHandler (int exc_type)
{
  type = exc_type;
  InstallExcHandler (NULL);
  cout << "CExcHandler created" << endl;
}

CExcHandler::~CExcHandler()
{
  cout << "CExcHandler destroyed" << endl;
}

void CExcHandler::crash()
{
  FARPTR fp;
  UINT   page;
  char   buf [1];

  switch (type)
  {
    case 3 : EMIT (0xCC);    /* int 3 */
             break;
    case 6 : EMIT (0xF0);    /* LOCK an unlockable instruction */
             EMIT (0xE4);    /* lock: in al,40h                */
             EMIT (0x40);
             break;
#ifndef __DJGPP__
    case 11: FP_SET (fp,NULL,0x84);
             PeekFarByte (fp);
             break;
    case 14: _dx_add_umapg (SS_DATA,1,&page);
             *(char*)page = 1;
             break;
#endif
    case 12: *((char*) (buf+0x10000)) = 1;
             break;
    case 13: *((char*)-1) = 1;
             break;
    default: cout << "No action for exception " << type << " defined\n";
  }
}

int main (int argc, char **argv)
{
  if (argc != 2)
  {
    cout << "Usage: demo_9 <exc-number 3,6,11,14,12 or 13>" << endl;
    return (1);
  }

  CExcHandler exc (atoi(argv[1]));
  exc.crash();

  return (0);
}
